/* 
**	deconv.h
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>
//#include <fcntl.h>
//#include <setjmp.h>
//-------------------------- X-window ------------------------
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#define SH_MEM
#ifdef SH_MEM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif
//-------------------------- defines ------------------------
//#define Long64/* 64 bit machine: alpha */
#define LE	/* little endian: alpha, pentium */
//------------------------- parameters ----------------------
#define H 20
#define V 20
#define D 8
#define SX 512
#define SY 512
//#define GET_PSF
//#define PART
#define LOOP  10
#define HLOOP 30
#define ADL  2
#define SMPL 3
#define PSFM SMPL

#define SHRINK_FIL
#define EXPAND_FIL
#define EXP_IMG_FIL
//#define GAUSS 3
//#define LPC
//#define Wiener
//#define WienerL
//#define INV_MAT
#define IIR1	// Hierarchical
//#define IIR2	// Divisional (But it uses 2-dimensional arrays[SY][SX])
//#define IIR3	// Hierarchical & Divisional
#define Unified // estimate through filtering
//#define BEST  // distingish ests before/after change
#define Damp	// damped R-L by nonlinear
//#define REAL	// center adjust by float
//#define CENTAF// center adjust per frame
//#define CENTROID// center adjust per layer
#define OFFSET 0// offset of input
#define FULLP

#define HIR  2  // 4 for def., 2 for ina3.yuv
//#define T 1E-8

//#define GAMMA
//#define sRGB
#ifdef sRGB
#define GMM   2.4
#define IGM   (1./GMM)
#define GRD   12.92
#define LID   0.0031308
#define EXX   0.055
#else
//#define BT709
#ifdef BT709
#define IGM   0.450     // (ITU-R BT.709,SMPTE 170M,240M: 0.45)
#define GMM   (1./IGM)  //
#define GRD   4.500     // (ITU-R BT.709,SMPTE 170M: 4.5,   SMPTE 240M:4.0   )
#define LID   0.018     // (ITU-R BT.709,SMPTE 170M: 0.018, SMPTE 240M:0.0228)
#define EXX   0.099     // (ITU-R BT.709,SMPTE 170M: 0.099, SMPTE 240M:0.1115)
#else
#define GMM   5         //
#define IGM   (1./GMM)  //
#endif
#endif

#define MAX(a,b) (((a)<(b))?(b):(a))
#define MIN(a,b) (((a)>(b))?(b):(a))

#ifdef FULLP
#define LM(a,c) ((MIN(MAX((a),0),(c)-1)))
#else
#define LM(a,c) (a)
#endif
#define H2 ((H+1)/2)
#define V2 ((V+1)/2)
#define D2 ((D+1)/2)
#define H3 ((H2+1)/2)
#define V3 ((V2+1)/2)
#define D3 ((D2+1)/2)
#define H4 ((H3+1)/2)
#define V4 ((V3+1)/2)
#define D4 ((D3+1)/2)
#define H5 ((H4+1)/2)
#define V5 ((V4+1)/2)
#define D5 ((D4+1)/2)
#define PEX(n) ((n[j/2][i/2]+n[j/2][(i+1)/2]+n[(j+1)/2][i/2]+n[(j+1)/2][(i+1)/2])/4)
#define SPEL(a) ((a[j*2][i*2]+a[j*2][i*2+1]+a[j*2+1][i*2]+a[j*2+1][i*2+1])/4)

#define GE
#ifdef IIR2
#define GE	// global estimate img
#define FULL
//#define PART
//#define DIVD	// Divide
#endif

#ifdef DIVD
#define DX 4
#define DY 4
#else
#define DX (1<<(HIR-1))
#define DY DX
#endif

#define M (H/2)
#define Fs 512 // Fs >= H
//#define U (V/2)
#define P (H)
#define N (P*P)
//#define RECALC	// error recalc
#ifdef BEST
#define best es0	// estmate before change
#else
#define best es		// estimate changing or after change
#endif

#ifdef GE
#define es(y,x) est[sy+y][sx+x]
#define es0(y,x) est0[sy+y][sx+x]
#define in(y,x) inp[sy+y][sx+x]
#else
#define es(y,x) est[y][x]
#define es0(y,x) est0[y][x]
#define in(y,x) inp[y][x]
#endif
#define cp(a,b) memcpy(a,b,sizeof(b))

//-------------------------- typedefs ------------------------
typedef unsigned char  Uc;
typedef unsigned short Us;
typedef unsigned int   Ui;
typedef unsigned long  Ul;
typedef double         Dt;
typedef struct{ int x; int y; } pos;
typedef struct{ pos s; pos e; } rect;
//typedef struct{ Dt re; Dt im; } complex;
//typedef struct{ Uc y[SY  ][SX  ]; Uc c[2][SY/2][SX/2]; }Sif;
struct clp{
Ui mr[256]; Ui r[512];
Ui mg[256]; Ui g[512];
Ui mb[256]; Ui b[512];	/* rgb dither */
Ui my[256]; Ui y[512];
Ui mu[256]; Ui u[512];
Ui mv[256]; Ui v[512];	/* yuv dither */
Ui mq[256]; Ui sq[512];	/* square */
Ui mc[256]; Ui cl[512];	/* [0.255] clip */
	};
typedef struct clp Clp;
//-------------------------- externs  ------------------------
extern int	x2;
extern int	pdct;
extern int	cmp;
extern int	ddt;
extern int	bgc;
extern int	gray;
extern int	sync;
extern int	wid;
extern int	deb;
extern char	font[256][15];
extern char	name[256];
extern int	accl;
extern int	cutof;
extern int	dispf;
extern int	estm;
extern FILE	*f;
extern int	iloop;
extern int	psfm;
extern int	pre;
extern int	prm;
extern Uc	mat[V*H];
extern Dt	mat2[V][H];
extern int	peak_pos_x;
extern int	peak_pos_y;
extern int	use_gamma;
extern char	fn[256];

