/*
**		main.c
*/
#include "deconv.h"

int ddt;
int cmp;
int vhs;
int bgc;
int wid;
#define L 1024
Uc xlog[L];
char name[256]="init";
char fn[256];
char fnjpg[256];
char fnyuv[256];
FILE *f;

int gw(FILE*f) { int c= getc(f)<<8; return c+getc(f); }

int jpg_size(char *n, int *sx, int *sy)
{
	int c; Uc *p= xlog;

	if(!(f= fopen(n,"rb"))){ fprintf(stderr,"jpg open err\n"); return 0; }

	while((c= getc(f))==255);
	if(c!=0xd8){ fprintf(stderr,"no jpg file?\n"); return 0; }

lp:	while((c=getc(f))!=255 && c!=EOF);
	if(c==EOF){ fprintf(stderr,"jpg read err\n"); return 0; }

	while((c= getc(f))==255);
	if((c&0xf0)!=0xc0) { fseek(f,gw(f)-2,SEEK_CUR); goto lp; } // not SOF

	if(getc(f)) goto lp;		// length high is not 0?
	if(getc(f)< 11) goto lp;	// length low (file is too short?)

	c= getc(f); if(c!= 8 && c!= 12) goto lp; // 8 bit or 12 bit?
	*sy= gw(f); *sx= gw(f);		// get size y and x

	fclose(f);
	return 1;
}

int is_jpg_file_name(char *c)
{
	int len= strlen(c);
	if(len<4) return 0;
	if(!strncmp(c+len-4,".JPG",4)
	|| !strncmp(c+len-4,".jpg",4)) return 1;
	return 0;
}

int is_yuv_file_name(char *c)
{
	int len= strlen(c);
	if(len<4) return 0;
	if(!strncmp(c+len-4,".YUV",4)
	|| !strncmp(c+len-4,".yuv",4)) return 1;
	return 0;
}

//-- usage and main --

void usage(char *c)
{
fprintf(stderr,"Usage: %s [-param value] file.[yuv|jpg] ...\n",c);
fprintf(stderr,"\t-param def.: -estm 3, -psfm 3, -accl 2, -loop 30,\n");
fprintf(stderr,"\t-size XsizexYsize (for YUV files, ex. 512x512)\n");
fprintf(stderr,"\t-quiet (no display to X and no print PSF), -cutof\n");
exit(1);
}

int main(int c, char **v)
{
	int len,i,sx=SX,sy=SY,sz= SX*SY*3/2;
	char *cm= *v;
	Uc *in,*ot;
	int from_jpg= 0;
	int c0,isx=sx,isy=sy;
	float ver= 1.00;
	int x= 0;

	printf("Deconvution demo (Ver: %4.2f)(Copyright Winbond Corp. Japan 2007)\n",ver);
	c--; v++;
	while(c){
		     if(!strcmp(*v,"-estm")) { c--; estm=  atoi(*++v); }
		else if(!strcmp(*v,"-psfm")) { c--; psfm=  atoi(*++v); }
		else if(!strcmp(*v,"-accl")) { c--; accl=  atoi(*++v); }
		else if(!strcmp(*v,"-loop")) { c--; iloop= atoi(*++v); }
		else if(!strcmp(*v,"-quiet")) dispf= pre= prm= 0;
		else if(!strcmp(*v,"-cutof")){ c--; cutof= atoi(*++v); }
		else if(!strcmp(*v,"-v")) x= 1;
		else if(!strcmp(*v,"-size")) {
			c--; sscanf(*++v,"%dx%d",&sx,&sy); sz= sx*sy*3/2;
			printf("same size for YUV files: %dx%d\n",sx,sy); isx= sx; isy= sy;
		}
		else if(**v=='-'){ fprintf(stderr,"unknown option:%s\n",*v); usage(cm); }
		else break;
		c--; v++;
	}
	if(c==0) usage(cm);

	if(x) {
	printf(" is going to process %d source file(s) below:\n\n",c);
	i= 1;
	c0= c;
	while(c--) {
		sx= isx; sy= isy;		// use initial size for yuv file
		strcpy(fn,*v++);		// get file name
		len= strlen(fn);		// length of file name 
		if(is_jpg_file_name(fn)) {
			if(!jpg_size(fn,&sx,&sy)) continue;
			printf("%3d: %s",i,fn); fn[len-4]= 0;	// JPG file
		} else if(is_yuv_file_name(fn)) {
			printf("%3d: %s",i,fn); fn[len-4]= 0;	// YUV file
		} else continue;
		printf("\t (size: %4d x %4d)",sx,sy);
		printf(" will output: %s_est.jpg\n",fn);
		i++;
	}
	c= c0; v-=c0;	// go back to the first argument.
	printf("\n");
	printf("Would you really deconvolute (y/n)? (def.n)\n");
	printf("(you can stop the sequence at anytime by pressing Cntrol-C)\n");
	if(getchar()!='y') return 0;
	}

	while(c--){
		from_jpg= 0;
		sx= isx; sy= isy;		// use initial size for yuv file
		strcpy(fn,*v++); strcpy(fnyuv,fn); strcpy(fnjpg,fn);
		len= strlen(fn);

		if(is_jpg_file_name(fn)) {	// ext is JPG or jpg
			fn[len-4]= fnyuv[len-4]= 0; strcat(fnyuv,".yuv");
fr_jpg:			if(!jpg_size(fnjpg,&sx,&sy)) continue;
			sprintf(name,"convert %s %s",fnjpg,fnyuv);
			system(name);
			from_jpg= 1;
		} else if(is_yuv_file_name(fn)) {	// ext is yuv or YUV
			fn[len-4]= fnjpg[len-4]= 0; strcat(fnjpg,".jpg");
			from_jpg= 0;
		} else continue;

		if(x) {
		if(from_jpg) printf("Source JPEG %s (size %dx%d)\n",fnjpg,sx,sy);
		else	     printf("Source YUV  %s\n",fnyuv);
		}

		sz= sx*sy*3/2;
		in= malloc(sz); ot= malloc(sz);
		if(read_in_yuv_file(in,sz,fnyuv)) continue;
		memcpy(ot,in,sz);
		if(dispf){
			iwt(fnyuv,in,      12, 24,sx,sy,0);	// observed
			iwt("est",in,  24+512, 24,sx,sy,1);	// estimate
			iwt("psf",mat2,12,24, H, V,2);	// psf
		}
		if(cutof) {
			int x,y; peak_pos_x= peak_pos_y= 0;
			while(!(x=peak_pos_x) || !(y=peak_pos_y)){
				usleep(100000); wt(in,"get up-left pos");
			}
			cut_out(*v,x,y,512,512,ot); return 0;
		}
		if(from_jpg) sprintf(name,"rm %s",fnyuv);
		else sprintf(name, "convert -size %dx%d %s %s_bef.jpg",sx,sy,fnyuv,fn);
		system(name);
		if(x) printf("%s\n",name);

		if(x)printf("deconvolution start\n");
		deconv(sx,sy,sz,mat2,in,ot);	// deconvolution proc
		if(x)printf("deconvolution end\n");

		write_out(ot,sz,"o.yuv");
		sprintf(name, "convert -size %dx%d o.yuv %s_est.jpg; rm o.yuv",sx,sy,fn);
		system(name);
		if(x) printf("%s\n",name);

		free(in); free(ot);
	}
	if(x) printf("%d file(s) done.\n",c0);
	return 0;
}
